<template>
  <div>
    <GToolbar
      :i18n="i18n"
      add-btn-hint="dcc.common.refTypeDefinitionListType.add"
      @addElement="addRefTypeDefinitions"
    />
    <Signature class="mb-4" />
    <SoftwareList
      v-model="value.dccSoftware"
      class="mb-4"
      i18n-base="dcc.administrativeData.dccSoftware"
      wiki-entry="dccSoftware"
    />
    <RefTypeDefinitionList
      v-if="value.refTypeDefinitions"
      ref="refTypeDefinitions"
      v-model="value.refTypeDefinitions"
      optional
      class="mb-4"
      @delete="deleteRefTypeDefinitions"
    />
    <CoreData v-model="value.coreData" class="mb-4" wiki-entry="coreData" />
    <CalibrationLaboratory
      v-model="value.calibrationLaboratory"
      class="mb-4"
      wiki-entry="calibrationLaboratory"
    />
    <RespPersonList
      v-model="value.respPersons"
      class="mb-4"
      wiki-entry="respPerson"
    />
    <Contact
      v-model="value.customer"
      i18n="dcc.administrativeData.customer"
      wiki-entry="customer"
    />
  </div>
</template>

<script>
import { RefTypeDefinitionListType } from "@d-ptb/dcc-js";
import RespPersonList from "./AdministrativeData/RespPersonList";
import CoreData from "./AdministrativeData/CoreData";
import Contact from "./Common/Contact";
import CalibrationLaboratory from "./AdministrativeData/CalibrationLaboratory";
import SoftwareList from "~/components/DCC/Common/SoftwareList";
import RefTypeDefinitionList from "~/components/DCC/AdministrativeData/RefTypeDefinitionList.vue";
import GToolbar from "~/components/App/Common/GToolbar.vue";
import Signature from "~/components/DCC/Signature.vue";

export default {
  name: "GeneralInformation",
  components: {
    Signature,
    GToolbar,
    RefTypeDefinitionList,
    SoftwareList,
    CalibrationLaboratory,
    Contact,
    CoreData,
    RespPersonList,
  },
  props: {
    value: Object,
    i18n: String,
  },
  methods: {
    addRefTypeDefinitions() {
      this.$set(
        this.value,
        "refTypeDefinitions",
        new RefTypeDefinitionListType()
      );
      this.$nextTick(() => {
        this.$vuetify.goTo(this.$refs.refTypeDefinitions);
      });
    },
    deleteRefTypeDefinitions() {
      confirm(this.$t("dcc.common.refTypeDefinitionListType.confirmRemove")) &&
        this.$delete(this.value, "refTypeDefinitions");
    },
  },
};
</script>
